#File Remover VER 0.3
#Gavrishev Alexandr (anod)
#mailto: alex.gavrishev@gmail.com
#SYMBIANUID=0x10201520
#
# -*- coding: utf-8 -*-

import os
import appuifw
import e32
import string
import codecs

hmain = None
class Filebrowser:
	def __init__(self, hmain):
		self.hmain = hmain
		self.entries = []
		self.dirlist = []
	def run(self):
		self.get_dirs()
		self.lb = appuifw.Listbox(self.entries, self.lbox_observe)
		self.refresh()
	def refresh(self):
		appuifw.app.title = u"Choose Dir"
		appuifw.app.menu = [(u'Open Folder',lambda:self.lbox_observe()),(u'Select Folder',lambda:self.select_folder()),(u'Exit',lambda:self.exit_key_handler())]
		appuifw.app.exit_key_handler = self.exit_key_handler
		appuifw.app.body = self.lb
	def get_dirs(self):
		if len(self.dirlist) == 0:
			self.entries = e32.drive_list()
			self.dirlist = []
		else:
			self.entries = []
			cpath = string.join(self.dirlist,os.sep)+os.sep
			cpath = cpath.encode('utf-8')
			for file in os.listdir(str(cpath)):
				full_name = os.path.join(str(cpath), file)
				if os.path.isdir(full_name):
					self.entries.append(unicode(file,encoding='utf-8', errors='replace'))
			self.entries.insert(0, u'..')
	def select_folder(self):
		cidx=self.lb.current()
		cfile=self.entries[cidx]
		if (cfile != '..'):
			if len(self.dirlist) == 0:
				cpath = unicode(cfile+os.sep)
			else:
				cpath = unicode(string.join(self.dirlist,os.sep)+os.sep+cfile+os.sep)
			cpath = cpath.encode('utf-8')
			files_arr = []
			for file in os.listdir(str(cpath)):
				full_name = os.path.join(str(cpath), file)
				if not os.path.isdir(full_name):
					files_arr.append(unicode(file,encoding='utf-8', errors='replace'))
			if (len(files_arr) > 0):
				selection = appuifw.multi_selection_list(files_arr, style='checkbox', search_field=0)
				if selection:
					sel_files = []
					new_items = u''
					sel_files = [files_arr[i] for i in selection]
					cpath = unicode(cpath,encoding='utf-8', errors='replace')
					for file in sel_files:
						new_items = new_items + cpath + file + ';'
					new_items = new_items[:-1].encode('utf-8')
					self.hmain.add_br_items(new_items)
					self.exit_key_handler()
				else:
					appuifw.note(u'You not selected items')
	def exit_key_handler(self):
		self.hmain.refresh()
	def lbox_observe(self):
		cidx=self.lb.current()
		cfile=unicode(self.entries[cidx])
		if (cfile == u'..'):
			if (len(self.dirlist)-1 > 0):
				self.dirlist=self.dirlist[:-1]
			else:
				self.dirlist=[]
		else:
				self.dirlist.append(cfile)
		self.get_dirs()
		self.lb.set_list(self.entries, 0)
class Fremover:
	def __init__(self):
		self.script_lock = e32.Ao_lock()
		self.entries = []
		self.cfg = 'e://System//Apps//fremover//cfg.lst'
		self.errlog='c://frm.log'
		self.cindx = 0
		self.lb = None
		self.FileBorwser = None
		self.get_list()
		if len(self.entries)<=0:
			self.entries.append((u'Please, add items...',u''))
		self.lb = appuifw.Listbox(self.entries, self.lbox_observe)
		self.refresh()
		self.script_lock.wait()
	def refresh(self):
		appuifw.app.title = u'File remover'
		appuifw.app.menu = [(u'Remove file',lambda:self.del_file()),(u'List',((u'Browse for items',lambda:self.browse_item()),(u'Add item',lambda:self.add_item()),(u'Edit item',lambda:self.edit_item()),(u'Delete item',lambda:self.del_item())))]
		appuifw.app.exit_key_handler = self.exit_key_handler
		appuifw.app.body = self.lb
	def save_list(self):
		F=codecs.open(self.cfg,'w','utf-8')
		for name,path in self.entries:
			F.write(name+'|'+path+'\n')
		F.close()
		if (self.lb!=None):
			self.lb.set_list(self.entries, 0)
	def get_list(self):
		if os.path.exists(self.cfg)==1:
			F=codecs.open(self.cfg,'r','utf-8')
			while 1:
				line=F.readline()
				if line=='':
					break
				line=line[:-1]
				[name,path]=string.split(line,'|')
				self.entries.append((unicode(name),unicode(path)))
			F.close()
		else:
			self.entries=[]
			self.entries.append((u'MSearch',u'e:/system/apps/mobilesearch/msearch.cfg'))
			self.entries.append((u'Netfront 3.2',u'c:/system/shareddata/101fed88.ini'))
			self.entries.append((u'N-Gage Libs',u'e:/system/libs/ecom.dll;e:/system/libs/ecomserver.exe;e:/system/libs/http.dll;e:/system/libs/httptcphnd.dll;e:/system/libs/inetprotutil.dll;e:/system/libs/loaderclings.dll;e:/system/libs/loadersrvngs.exe;e:/system/libs/ncuibrowser.dll;e:/system/libs/ncuiutil.dll;e:/system/libs/ncuibrowserngs.dll;e:/system/libs/rbinterpreterngs.dll;e:/system/libs/securesocket.dll;e:/system/libs/ssl70.dll;e:/system/libs/ssladaptor.dll'))
			self.save_list()
	def browse_item(self):
		self.FileBrowser = Filebrowser(self)
		self.FileBrowser.run()
	def add_br_items(self,path):
		name = None
		name=appuifw.query(u'Name','text',u'')
		if (name!=None):
			if (unicode(self.entries[0][0]) == unicode('Please, add items...')):
				del self.entries[0]
				if len(self.entries)<=0:
					self.entries=[]
			path = unicode(path,encoding='utf-8', errors='replace')
			self.entries.append((name,path))
			self.save_list()
	def add_item(self):
		name,path='',''
		[name,path]=appuifw.multi_query(u'Name',u'Path')       
		if (name!=None):
			if (unicode(self.entries[0][0]) == unicode('Please, add items...')):
				del self.entries[0]
				if len(self.entries)<=0:
					self.entries=[]  
			self.entries.append((name,path))
			self.save_list()
	def edit_item(self):
		name,nname,path,npath='','','',''
		self.cindx=self.lb.current()
		#appuifw.note(unicode(self.entries[self.cindx]))
		if (unicode(self.entries[self.cindx][0]) != unicode('Please, add items...')):
			name=self.entries[self.cindx][0]
			nname=appuifw.query(u'Name','text',name)
			path=self.entries[self.cindx][1]
			npath=appuifw.query(u'Path','text',path)
			if nname==None:
				nname=name
			if npath==None:
				npath=path
			self.entries[self.cindx]=(nname,npath)
			self.save_list()
	def del_item(self):
		self.cindx=self.lb.current()
		if appuifw.query(u'Do you want to delete this entry?','query'):
			del self.entries[self.cindx]
			if len(self.entries)<=0:
				self.entries.append((u'Please, add items...',u''))
			self.save_list()
	def del_file(self):
		if (unicode(self.entries[self.cindx][0]) != unicode('Please, add items...')):
			if appuifw.query(u'Do you want to remove this files?','query'):
				fnames=string.split(self.entries[self.cindx][1],';')
				errors = u''
				for fname in fnames:
					try:
						#fname = unicode(fname,encoding='utf-8', errors='replace')
						fname = fname.encode('utf-8')
						os.remove(fname)
					except:
						errors = errors.encode('utf-8') +fname + '\n'
				if (errors == ''):
					appuifw.note(u'Files was deleted')
				else:
					F=codecs.open(self.errlog,'w','utf-8')
					errors = unicode(errors,encoding='utf-8', errors='replace')
					F.write(u'FileRemover Errors Log:\n'+errors)
					F.close()
					appuifw.note(u'Failed! See Log: '+unicode(self.errlog))
	def exit_key_handler(self):
		appuifw.app.exit_key_handler = None
		self.script_lock.signal()
	def lbox_observe(self):        
		self.cindx=self.lb.current()
		self.del_file()
		self.lb.set_list(self.entries, 0)

if __name__ == '__main__':
	hmain = Fremover()

